# Ogre::GpuProgramPtr Class Reference

Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr. More...

`#include <OgreGpuProgram.h>`

Inheritance diagram for Ogre::GpuProgramPtr:

List of all members.

## Public Member Functions

| GpuProgramPtr ()
| GpuProgramPtr (GpuProgram *rep)
| GpuProgramPtr (const GpuProgramPtr &r)
| GpuProgramPtr (const ResourcePtr &r)
GpuProgramPtr & | operator= (const ResourcePtr &r)
| Operator used to convert a ResourcePtr to a GpuProgramPtr.
GpuProgramPtr & | operator= (const HighLevelGpuProgramPtr &r)
| Operator used to convert a HighLevelGpuProgramPtr to a GpuProgramPtr.
OGRE_AUTO_SHARED_MUTEX | SharedPtr ()
| Constructor, does not initialise the SharedPtr.
| SharedPtr (GpuProgram *rep)
| SharedPtr (const SharedPtr &r)
GpuProgram & | operator * () const
GpuProgram * | operator-> () const
GpuProgram * | get () const
void | bind (GpuProgram *rep)
| Binds rep to the SharedPtr.
bool | unique () const
unsigned int | useCount () const
unsigned int * | useCountPointer () const
GpuProgram * | getPointer () const
bool | isNull (void) const
void | setNull (void)

## Protected Member Functions

void | release (void)
virtual void | destroy (void)

## Protected Attributes

GpuProgram * | pRep
unsigned int * | pUseCount

## Detailed Description

Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.

Note:
  Has to be a subclass since we need operator=. We could templatise this instead of repeating per Resource subclass, except to do so requires a form VC6 does not support i.e. ResourceSubclassPtr<T> : public SharedPtr<T>

Definition at line 1139 of file OgreGpuProgram.h.

## Constructor & Destructor Documentation

Ogre::GpuProgramPtr::GpuProgramPtr | ( |  | ) |

| Definition at line 1142 of file OgreGpuProgram.h.

Ogre::GpuProgramPtr::GpuProgramPtr | ( | GpuProgram * | rep | ) | `[explicit]`

| Definition at line 1143 of file OgreGpuProgram.h.

Ogre::GpuProgramPtr::GpuProgramPtr | ( | const GpuProgramPtr & | r | ) |

| Definition at line 1144 of file OgreGpuProgram.h.

Ogre::GpuProgramPtr::GpuProgramPtr | ( | const ResourcePtr & | r | ) |

| Definition at line 1145 of file OgreGpuProgram.h.

## Member Function Documentation

void Ogre::SharedPtr< GpuProgram >::bind | ( | GpuProgram * | rep | ) | `[inherited]`

Binds rep to the SharedPtr.

Remarks:
  Assumes that the SharedPtr is uninitialised!

Definition at line 114 of file OgreSharedPtr.h.

virtual void Ogre::SharedPtr< GpuProgram >::destroy | ( | void |  | ) | `[protected, virtual, inherited]`

| Definition at line 168 of file OgreSharedPtr.h.

GpuProgram * Ogre::SharedPtr< GpuProgram >::get | ( |  | ) | const`[inherited]`

| Definition at line 108 of file OgreSharedPtr.h.

GpuProgram * Ogre::SharedPtr< GpuProgram >::getPointer | ( |  | ) | const`[inherited]`

| Definition at line 126 of file OgreSharedPtr.h.

bool Ogre::SharedPtr< GpuProgram >::isNull | ( | void |  | ) | const`[inherited]`

| Definition at line 128 of file OgreSharedPtr.h.

GpuProgram & Ogre::SharedPtr< GpuProgram >::operator * | ( |  | ) | const`[inherited]`

| Definition at line 106 of file OgreSharedPtr.h.

GpuProgram * Ogre::SharedPtr< GpuProgram >::operator-> | ( |  | ) | const`[inherited]`

| Definition at line 107 of file OgreSharedPtr.h.

GpuProgramPtr& Ogre::GpuProgramPtr::operator= | ( | const HighLevelGpuProgramPtr & | r | ) |

| Operator used to convert a HighLevelGpuProgramPtr to a GpuProgramPtr.

GpuProgramPtr& Ogre::GpuProgramPtr::operator= | ( | const ResourcePtr & | r | ) |

| Operator used to convert a ResourcePtr to a GpuProgramPtr. Definition at line 1162 of file OgreGpuProgram.h. References Ogre::SharedPtr< T >::getPointer(), OGRE_COPY_AUTO_SHARED_MUTEX, OGRE_LOCK_MUTEX, OGRE_MUTEX_CONDITIONAL, and Ogre::SharedPtr< T >::useCountPointer().

void Ogre::SharedPtr< GpuProgram >::release | ( | void |  | ) | `[protected, inherited]`

| Definition at line 142 of file OgreSharedPtr.h.

void Ogre::SharedPtr< GpuProgram >::setNull | ( | void |  | ) | `[inherited]`

| Definition at line 130 of file OgreSharedPtr.h.

Ogre::SharedPtr< GpuProgram >::SharedPtr | ( | const SharedPtr< GpuProgram > & | r | ) | `[inherited]`

| Definition at line 64 of file OgreSharedPtr.h.

Ogre::SharedPtr< GpuProgram >::SharedPtr | ( | GpuProgram * | rep | ) | `[explicit, inherited]`

| Definition at line 59 of file OgreSharedPtr.h.

OGRE_AUTO_SHARED_MUTEX Ogre::SharedPtr< GpuProgram >::SharedPtr | ( |  | ) | `[inherited]`

Constructor, does not initialise the SharedPtr.

Remarks:
  Dangerous! You have to call bind() before using the SharedPtr.

Definition at line 54 of file OgreSharedPtr.h.

bool Ogre::SharedPtr< GpuProgram >::unique | ( |  | ) | const`[inherited]`

| Definition at line 122 of file OgreSharedPtr.h.

unsigned int Ogre::SharedPtr< GpuProgram >::useCount | ( |  | ) | const`[inherited]`

| Definition at line 123 of file OgreSharedPtr.h.

unsigned int* Ogre::SharedPtr< GpuProgram >::useCountPointer | ( |  | ) | const`[inherited]`

| Definition at line 124 of file OgreSharedPtr.h.

## Member Data Documentation

GpuProgram * Ogre::SharedPtr< GpuProgram >::pRep `[protected, inherited]`

| Definition at line 46 of file OgreSharedPtr.h.

unsigned int* Ogre::SharedPtr< GpuProgram >::pUseCount `[protected, inherited]`

| Definition at line 47 of file OgreSharedPtr.h.

The documentation for this class was generated from the following file:

- OgreGpuProgram.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Sep 17 15:39:55 2006